<!doctype html>
<html class="no-js">
<head>
  
  
  
  <meta charset="utf-8">
  <title>Learn Python the Hard Way</title>

  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="description" content="">
  <meta name="viewport" content="width=device-width,initial-scale=1">

  <link href="https://www.google-analytics.com/" rel="dns-prefetch">
  <link href="https://ajax.googleapis.com/" rel="dns-prefetch">

  <link href='https://fonts.googleapis.com/css?family=Source+Code+Pro|Source+Sans+Pro:200,400,700,200italic,400italic,700italic' rel='stylesheet' type='text/css'>
  <link href="css/style.min.css" rel="stylesheet">
  <!-- http://www.socicon.com -->
  <link href="css/icons.css" rel="stylesheet">


</head>

<body id="top">


  
  
<header class="header" role="banner">
  <nav class="navbar navbar-full nav-brand-family">
    <div class="row middle-xs">
      <ul class="brand-links show-md col-xs-3 col-sm-10 bare">
        <li><a href="http://learncodethehardway.org" class="waves-effect">Learn:</a></li>
        
        <li><a href="http://learncodethehardway.org/python/" class="waves-effect active">Python</a></li>
        
        <li><a href="http://learncodethehardway.org/ruby/" class="waves-effect">Ruby</a></li>
        
        <li><a href="http://learncodethehardway.org/more-python/" class="waves-effect">More Python</a></li>
        
        <li><a href="http://learncodethehardway.org/c/" class="waves-effect">C</a></li>
        
        <li><a href="http://learncodethehardway.org/sql/" class="waves-effect">SQL</a></li>
        
        <li><a href="http://learncodethehardway.org/javascript/" class="waves-effect">Javascript</a></li>
        
        <li><a href="http://learncodethehardway.org/unix/" class="waves-effect">Unix</a></li>
        
        <li><a href="http://learncodethehardway.org/regex/" class="waves-effect">RegEx</a></li>
        
        <li><a href="http://www.learndesignthehardway.com/" class="waves-effect">Design</a></li>
        
      </ul>
      <ul class="brand-links hide-md col-xs-3 col-sm-10 bare">
        <li><a href="http://learncodethehardway.org/" class="waves-effect">LCTHW</a></li>
      </ul>
      
      <ul class="site-meta col-xs-9 col-sm-2 end-xs bare">
        <li><a href="https://shop.learncodethehardway.org/access/reactivate/" class="waves-effect"><i class="icon icon-user"></i> Login</a></li>
      </ul>
      
    </div>
  </nav>
  
</header>







<div class="masthead python-background" style="background-image: url('/images/pattern-python.svg')">
  <img src="images/logo-python.svg" alt="Learn Python the Hard Way" class="logo">
</div>

<div class="content python">
  <div class="container-fluid">

    <div class="row around-xs">
      <div class="col-xs-11 col-sm-8 col-md-6">
        <h1>Millions of people have learned to code. So can you.</h1>
        <p>The original Hard Way book and still the most popular way for total beginners to finally learn how to code.  Learn Python The Hard Way takes you from absolute zero to able to read and write basic Python to then understand other books on Python.  No experience necessary to begin, and you can even try the book out for free to see if the method works for you. If you&#39;ve always wanted to learn to code but have no idea where to begin, then this book is for you.</p>
        <p class="text-center">
          <a href="https://learnpythonthehardway.org/learnpythonthehardway_default_2.html#buy" class="btn btn-primary">Get the book</a>
        </p>
      </div>
    </div>

  </div>

  <div class="row dark shave-bottom social-proof">
    <div class="col-xs-10 col-xs-offset-1 col-sm-8 col-sm-offset-2">
      

<blockquote data-id="0" class="visible">
  <div class="inner">
    <p>Thanks so much for putting your book online. It has served as a tremendous resource on learning python and just wanted to say I really appreciate it. People like you make this world a better place.</p>
    <footer><cite class="author">Michael</cite></footer>
  </div>
</blockquote>


<blockquote data-id="1" class="">
  <div class="inner">
    <p>Hey man just wanted to say you really made it easy to learn from being a beginner. The command line does suck and is really boring but I can tell once I start becoming familiar with it everyday it will be second nature. </p>
    <footer><cite class="author">Kennon</cite></footer>
  </div>
</blockquote>


<blockquote data-id="2" class="">
  <div class="inner">
    <p>Just wanted to send a quick thank you for giving me confidence in trying to learn to code. I’m 28 now and didn’t think it was something I could do – (it still might not be) – but thanks to your book it’s given me an opportunity I don’t want to miss out on. Love your passion and it’s very inspiring.</p>
    <footer><cite class="author">Peter</cite></footer>
  </div>
</blockquote>


<blockquote data-id="3" class="">
  <div class="inner">
    <p>I started doing your Python course when I was unemployed...and it made a huge difference in my life. Because I had some programming knowledge, I was able to get a job for a financial company that needed someone who could do a bit of coding in addition to their regular duties. ... Now, I&#39;ve gone from being one of the long-term unemployed to looking at buying my first home.</p>
    <footer><cite class="author">Marshal</cite></footer>
  </div>
</blockquote>


<blockquote data-id="4" class="">
  <div class="inner">
    <p>Briefly I’m a 61 year old retire[d] business consultant who has always love computers. Decided to learn programming and starting with your course. As one who has done lots of teaching allow me to compliment the course and your style. Just finished Exercise 12 and wanted to say thanks for putting this course together!</p>
    <footer><cite class="author">Bert</cite></footer>
  </div>
</blockquote>


<blockquote data-id="5" class="">
  <div class="inner">
    <p>I&#39;ve just bought Learn C the Hard Way while on a business trip, since the beta edition website has been incredibly useful. Thanks for that, by the way! Writing the simple database with dynamically allocated fields was more empowering than almost anything I&#39;ve done as a programmer so far.</p>
    <footer><cite class="author">Roman</cite></footer>
  </div>
</blockquote>


<blockquote data-id="6" class="">
  <div class="inner">
    <p>Also I may as well take the opportunity to mention that as a PHP dev the C course is exactly what I was looking for and is frankly excellent. So thank you very much!</p>
    <footer><cite class="author">Michael</cite></footer>
  </div>
</blockquote>


<blockquote data-id="7" class="">
  <div class="inner">
    <p>I would like to say that I find your material absolutely terrific. Very pedagogical and methodical, taking it nice and slow. Perfect for a beginner and someone who thinks that technology can be a little intimidating like me. I&#39;ve been running my own businesses for some years and have come to the realization how important it is to know at least some coding. Most importantly in order to be able to talk to and understand programmers (and balance up the information asymmetry), as well as making your own prototypes without the need to resort to external expertise.</p>
    <footer><cite class="author">Michael</cite></footer>
  </div>
</blockquote>


<blockquote data-id="8" class="">
  <div class="inner">
    <p>To be completely honest, programming is one of the best things I have experienced. Truly. The combination of getting a chance to train your logic and making use of your own creativity is so very rewarding. And the almost endless number of applications you can put that knowledge into use is inspiring. I try to do at least 2 hours of programming every day, and it&#39;s something I look forward to each time I get out of bed. Thanks for that Zed! Without your online course I wouldn&#39;t have dared to take the leap.</p>
    <footer><cite class="author">Michael</cite></footer>
  </div>
</blockquote>


<blockquote data-id="9" class="">
  <div class="inner">
    <p>I just completed the command line crash course and want to express my feeling towards your lessons and teaching methods. I have been learning all over the web about coding and very few places make me feel like I’m grasping the methods. I like how you “made” me make flash cards and things felt like a true bootcamp. I have learned a lot more about the command line and am not so afraid of it anymore. I wanted to ask if you have any JavaScript writings as I did not see any on your webpage, I will definitely be reading Ruby but JavaScript is really tripping me up in places and I could use better explanations for things than the ones I’ve seen.</p>
    <footer><cite class="author">Kevin</cite></footer>
  </div>
</blockquote>


<blockquote data-id="10" class="">
  <div class="inner">
    <p>I&#39;m reading your book, Learn Python the Hard Way, and really enjoying it. Your teaching approach is the best. I remember at the university, we would have to reach large and dense chapters on programming concepts before writing a line of code. It was insufferable. It should be the other way around, as you have recognized, writing code first and later reading as much about it as is necessary or desired. That deep understanding is important, but it&#39;s really impossible to achieve through reading alone and must instead spring forth from a foundation of hands on experience.</p>
    <footer><cite class="author">Christopher</cite></footer>
  </div>
</blockquote>


<blockquote data-id="11" class="">
  <div class="inner">
    <p>Thank you so much for the great resource you have provided in Learn C The Hard Way. To give you some positive feedback, I recently used your site to refresh my C skills from Uni, having not used them in anger for a number of years. At the conclusion I applied for work as a C \ Python developer. I feel as though I put my best foot forward, and my inner software engineer has gotten back its spark.</p>
    <footer><cite class="author">Anonymous</cite></footer>
  </div>
</blockquote>


<blockquote data-id="12" class="">
  <div class="inner">
    <p>I just wanted to let you know that this course is awesome. I&#39;m following all of the instructions and everything makes sense, so I don&#39;t actually need help. I just wanted to thank you. This is a really well constructed course and well worth the very affordable expense. Cheers.</p>
    <footer><cite class="author">Nathan</cite></footer>
  </div>
</blockquote>


<blockquote data-id="13" class="">
  <div class="inner">
    <p>I really appreciate what you have given back and I agree with your [writings]. You have helped my career tremendously. Thank you from the bottom of my fingers.</p>
    <footer><cite class="author">Anthony</cite></footer>
  </div>
</blockquote>


<blockquote data-id="14" class="">
  <div class="inner">
    <p>I would like to thank you for writing your books. About 8 months ago I was ready to try something new. I had never done any programming before but I have a few friends and relatives who do it for a living and thought I would give it a try. I came across your books and got to work. The way your books are organized and how each chapter progressed in simple steps helped me a lot. I also appreciated your straight forward attitude and tone throughout. I just released my first iOS app for sale.</p>
    <footer><cite class="author">Greg</cite></footer>
  </div>
</blockquote>


<blockquote data-id="15" class="">
  <div class="inner">
    <p>I recently finished LPTHW and greatly enjoyed it. Python’s readability and your teaching approach really helped me to finally overcome some mental obstacles to developing programming abilities that have frustrated me for a long time. I appreciate you making your knowledge available to the world for free. I found your &#39;what to tell know-it-all programmers&#39; and general life observations just as interesting as the code.</p>
    <footer><cite class="author">Drew</cite></footer>
  </div>
</blockquote>


<blockquote data-id="16" class="">
  <div class="inner">
    <p>Can I just say how grateful I am to you for writing this book. It is the first thing I have found that has made me feel like, I can get it together and learn to code.</p>
    <footer><cite class="author">Alexander</cite></footer>
  </div>
</blockquote>



    </div>
  </div>

  <div class="row shave-bottom section-features">
    <h1 class="section-title">All Courses Include</h1>
<div class="col-xs-10 col-xs-offset-1 col-sm-8 col-sm-offset-2">
  <div class="icon-panel">
    <div class="icon-panel__item">
      <div class="icon-panel__image"><i class="icon-unlocked"></i></div>
      <h3 class="icon-panel__title">DRM Free</h3>
      <p>You bought it. You get to keep it. Download it and watch it whenever you want.</p>
    </div>
    <div class="icon-panel__item">
      <div class="icon-panel__image"><i class="icon-document"></i></div>
      <h3 class="icon-panel__title">Professional PDF</h3>
      <p>Professionally rendered PDFs you can download and view anywhere.</p>
    </div>
    <div class="icon-panel__item">
      <div class="icon-panel__image"><i class="icon-video"></i></div>
      <h3 class="icon-panel__title">HD Video</h3>
      <p>High quality video screencasts of Zed working through each exercise.</p>
    </div>
    <div class="icon-panel__item">
      <div class="icon-panel__image"><i class="icon-email"></i></div>
      <h3 class="icon-panel__title">Tech Support</h3>
      <p>Email support and get help when you’re stuck.</p>
    </div>
    <div class="icon-panel__item">
      <div class="icon-panel__image"><i class="icon-upload"></i></div>
      <h3 class="icon-panel__title">Free Updates</h3>
      <p>You’ll receive free updates until the next edition is announced.</p>
    </div>
    <div class="icon-panel__item">
      <div class="icon-panel__image"><i class="icon-pants"></i></div>
      <h3 class="icon-panel__title">60 Day Guarantee</h3>
      <p>60 days to try it and get a refund if you don't like it.</p>
    </div>
  </div>
</div>

  </div>

  <div class="row dark shave-bottom social-proof">
    <div class="col-xs-10 col-xs-offset-1 col-sm-8 col-sm-offset-2">
      

<blockquote data-id="0" class="visible">
  <div class="inner">
    <p>Thanks so much for putting your book online. It has served as a tremendous resource on learning python and just wanted to say I really appreciate it. People like you make this world a better place.</p>
    <footer><cite class="author">Michael</cite></footer>
  </div>
</blockquote>


<blockquote data-id="1" class="">
  <div class="inner">
    <p>Hey man just wanted to say you really made it easy to learn from being a beginner. The command line does suck and is really boring but I can tell once I start becoming familiar with it everyday it will be second nature. </p>
    <footer><cite class="author">Kennon</cite></footer>
  </div>
</blockquote>


<blockquote data-id="2" class="">
  <div class="inner">
    <p>Just wanted to send a quick thank you for giving me confidence in trying to learn to code. I’m 28 now and didn’t think it was something I could do – (it still might not be) – but thanks to your book it’s given me an opportunity I don’t want to miss out on. Love your passion and it’s very inspiring.</p>
    <footer><cite class="author">Peter</cite></footer>
  </div>
</blockquote>


<blockquote data-id="3" class="">
  <div class="inner">
    <p>I started doing your Python course when I was unemployed...and it made a huge difference in my life. Because I had some programming knowledge, I was able to get a job for a financial company that needed someone who could do a bit of coding in addition to their regular duties. ... Now, I&#39;ve gone from being one of the long-term unemployed to looking at buying my first home.</p>
    <footer><cite class="author">Marshal</cite></footer>
  </div>
</blockquote>


<blockquote data-id="4" class="">
  <div class="inner">
    <p>Briefly I’m a 61 year old retire[d] business consultant who has always love computers. Decided to learn programming and starting with your course. As one who has done lots of teaching allow me to compliment the course and your style. Just finished Exercise 12 and wanted to say thanks for putting this course together!</p>
    <footer><cite class="author">Bert</cite></footer>
  </div>
</blockquote>


<blockquote data-id="5" class="">
  <div class="inner">
    <p>I&#39;ve just bought Learn C the Hard Way while on a business trip, since the beta edition website has been incredibly useful. Thanks for that, by the way! Writing the simple database with dynamically allocated fields was more empowering than almost anything I&#39;ve done as a programmer so far.</p>
    <footer><cite class="author">Roman</cite></footer>
  </div>
</blockquote>


<blockquote data-id="6" class="">
  <div class="inner">
    <p>Also I may as well take the opportunity to mention that as a PHP dev the C course is exactly what I was looking for and is frankly excellent. So thank you very much!</p>
    <footer><cite class="author">Michael</cite></footer>
  </div>
</blockquote>


<blockquote data-id="7" class="">
  <div class="inner">
    <p>I would like to say that I find your material absolutely terrific. Very pedagogical and methodical, taking it nice and slow. Perfect for a beginner and someone who thinks that technology can be a little intimidating like me. I&#39;ve been running my own businesses for some years and have come to the realization how important it is to know at least some coding. Most importantly in order to be able to talk to and understand programmers (and balance up the information asymmetry), as well as making your own prototypes without the need to resort to external expertise.</p>
    <footer><cite class="author">Michael</cite></footer>
  </div>
</blockquote>


<blockquote data-id="8" class="">
  <div class="inner">
    <p>To be completely honest, programming is one of the best things I have experienced. Truly. The combination of getting a chance to train your logic and making use of your own creativity is so very rewarding. And the almost endless number of applications you can put that knowledge into use is inspiring. I try to do at least 2 hours of programming every day, and it&#39;s something I look forward to each time I get out of bed. Thanks for that Zed! Without your online course I wouldn&#39;t have dared to take the leap.</p>
    <footer><cite class="author">Michael</cite></footer>
  </div>
</blockquote>


<blockquote data-id="9" class="">
  <div class="inner">
    <p>I just completed the command line crash course and want to express my feeling towards your lessons and teaching methods. I have been learning all over the web about coding and very few places make me feel like I’m grasping the methods. I like how you “made” me make flash cards and things felt like a true bootcamp. I have learned a lot more about the command line and am not so afraid of it anymore. I wanted to ask if you have any JavaScript writings as I did not see any on your webpage, I will definitely be reading Ruby but JavaScript is really tripping me up in places and I could use better explanations for things than the ones I’ve seen.</p>
    <footer><cite class="author">Kevin</cite></footer>
  </div>
</blockquote>


<blockquote data-id="10" class="">
  <div class="inner">
    <p>I&#39;m reading your book, Learn Python the Hard Way, and really enjoying it. Your teaching approach is the best. I remember at the university, we would have to reach large and dense chapters on programming concepts before writing a line of code. It was insufferable. It should be the other way around, as you have recognized, writing code first and later reading as much about it as is necessary or desired. That deep understanding is important, but it&#39;s really impossible to achieve through reading alone and must instead spring forth from a foundation of hands on experience.</p>
    <footer><cite class="author">Christopher</cite></footer>
  </div>
</blockquote>


<blockquote data-id="11" class="">
  <div class="inner">
    <p>Thank you so much for the great resource you have provided in Learn C The Hard Way. To give you some positive feedback, I recently used your site to refresh my C skills from Uni, having not used them in anger for a number of years. At the conclusion I applied for work as a C \ Python developer. I feel as though I put my best foot forward, and my inner software engineer has gotten back its spark.</p>
    <footer><cite class="author">Anonymous</cite></footer>
  </div>
</blockquote>


<blockquote data-id="12" class="">
  <div class="inner">
    <p>I just wanted to let you know that this course is awesome. I&#39;m following all of the instructions and everything makes sense, so I don&#39;t actually need help. I just wanted to thank you. This is a really well constructed course and well worth the very affordable expense. Cheers.</p>
    <footer><cite class="author">Nathan</cite></footer>
  </div>
</blockquote>


<blockquote data-id="13" class="">
  <div class="inner">
    <p>I really appreciate what you have given back and I agree with your [writings]. You have helped my career tremendously. Thank you from the bottom of my fingers.</p>
    <footer><cite class="author">Anthony</cite></footer>
  </div>
</blockquote>


<blockquote data-id="14" class="">
  <div class="inner">
    <p>I would like to thank you for writing your books. About 8 months ago I was ready to try something new. I had never done any programming before but I have a few friends and relatives who do it for a living and thought I would give it a try. I came across your books and got to work. The way your books are organized and how each chapter progressed in simple steps helped me a lot. I also appreciated your straight forward attitude and tone throughout. I just released my first iOS app for sale.</p>
    <footer><cite class="author">Greg</cite></footer>
  </div>
</blockquote>


<blockquote data-id="15" class="">
  <div class="inner">
    <p>I recently finished LPTHW and greatly enjoyed it. Python’s readability and your teaching approach really helped me to finally overcome some mental obstacles to developing programming abilities that have frustrated me for a long time. I appreciate you making your knowledge available to the world for free. I found your &#39;what to tell know-it-all programmers&#39; and general life observations just as interesting as the code.</p>
    <footer><cite class="author">Drew</cite></footer>
  </div>
</blockquote>


<blockquote data-id="16" class="">
  <div class="inner">
    <p>Can I just say how grateful I am to you for writing this book. It is the first thing I have found that has made me feel like, I can get it together and learn to code.</p>
    <footer><cite class="author">Alexander</cite></footer>
  </div>
</blockquote>



    </div>
  </div>

    <div class="row center-xs" id="buy">
    <div class="text-center col-xs-10 col-sm-5 col-md-4">
      <h2 class="section-title__small">Buy DRM-Free</h2>
      <p>
        When you buy directly from the author, Zed A. Shaw, you'll get a professional
        quality PDF and  hours of HD Video, all DRM-free and yours to download.
      </p>

      <p class="price-block">
      <span class="currency"><span class="prefix">$</span>29.<span class="suffix">99</span></span>
      </p>

      <a href="https://shop.learncodethehardway.org/access/buy/2/" class="btn btn-primary btn-full">Buy Digital Download Directly From The Author</a>
      
      <p class="text-left btn-subtext">
        <small>Or, you can <a href="https://learnpythonthehardway.org/book/book_2.html">read Learn Python the Hard Way for free</a> right here, video lectures not included.</small>
      </p>
      
    </div>
    <div class="text-center col-xs-10 col-sm-5 col-md-4 col-sm-offset-1">
      
      <h2 class="section-title__small">Other Buying Options</h2>
      <a href="http://bit.ly/amznlpthw" class="btn btn-secondary btn-full">Buy on Amazon</a>
      <a href="http://bit.ly/informitlpthw" class="btn btn-secondary btn-full">Buy a hard copy from Publisher</a>
          
          <a href="http://bit.ly/bnlpthw" class="btn btn-secondary btn-full">Buy a hard copy from Barnes &amp; Noble</a>
          
      
    </div>
  </div>




</div>


<footer class="footer">
  <div class="row center-xs">

  <div class="col-xs-11 col-sm-6 col-md-5 col-lg-5">
    <ul class="nav nav-inline">
      <li><h4><a href="https://learnpythonthehardway.org/learnpythonthehardway_default_2.html">Home</a></h4></li>
      <li><h4><a href="https://learncodethehardway.org/about/">About</a></h4></li>
      <li><h4><a href="https://learncodethehardway.org/contact/">Contact</a></h4></li>
    </ul>
    <div class="copyright text-left">
      <small class="text-muted">&copy; 2016 Zed A. Shaw</small>
    </div>
  </div>
  <div class="col-xs-11 col-sm-4 col-md-4 col-lg-3">
    <div class="social-media">
      <div class="classy-container">
        <a href="https://twitter.com/lzsthw" class="socicon-twitter"></a>
      </div>
    </div>
  </div>
</div>

</footer>
<script src="js/scripts.min.js"></script>

<!-- Start of helpthw Zendesk Widget script -->
<script>/*<![CDATA[*/window.zEmbed||function(e,t){var n,o,d,i,s,a=[],r=document.createElement("iframe");window.zEmbed=function(){a.push(arguments)},window.zE=window.zE||window.zEmbed,r.src="javascript:false",r.title="",r.role="presentation",(r.frameElement||r).style.cssText="display: none",d=document.getElementsByTagName("script"),d=d[d.length-1],d.parentNode.insertBefore(r,d),i=r.contentWindow,s=i.document;try{o=s}catch(e){n=document.domain,r.src='javascript:var d=document.open();d.domain="'+n+'";void(0);',o=s}o.open()._l=function(){var o=this.createElement("script");n&&(this.domain=n),o.id="js-iframe-async",o.src=e,this.t=+new Date,this.zendeskHost=t,this.zEQueue=a,this.body.appendChild(o)},o.write('<body onload="document._l();">'),o.close()}("https://assets.zendesk.com/embeddable_framework/main.js","helpthw.zendesk.com");
/*]]>*/</script>
<!-- End of helpthw Zendesk Widget script -->
<script>
  (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
  (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
  m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
  })(window,document,'script','https://www.google-analytics.com/analytics.js','ga');

  ga('create', 'UA-24168052-5', 'auto');
  ga('send', 'pageview');

</script>
</body>
</html>
